//+------------------------------------------------------------------+
//|                                                      SetStop.mq4 |
//|                              Copyright  2010, Khlystov Vladimir |
//|                                                cmillion@narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Khlystov Vladimir"
#property link      "cmillion@narod.ru"
//            , 
//    STOPLEVEL,     .
//--------------------------------------------------------------------
extern int stoploss   = 50, //  SL,  0,  SL  
           takeprofit = 50; //  TP,  0,  TP  
//--------------------------------------------------------------------
int start()
{
   int tip,Ticket;
   double SL,TP;
   double OOP,OSL,OTP;
   bool error;
   int STOPLEVEL = MarketInfo(Symbol(),MODE_STOPLEVEL);
   int SPREAD    = MarketInfo(Symbol(),MODE_SPREAD);
   if (stoploss<STOPLEVEL) stoploss=0; 
   if (takeprofit<STOPLEVEL) takeprofit=0; 
   Comment("SetStop   Copyright  2010, http://cmillion.narod.ru\n",
           " \n       = ",stoploss,"\n  = ",takeprofit
           ,"\nSTOPLEVEL  = ",STOPLEVEL);
   for (int i=0; i<OrdersTotal(); i++) 
   {  
      if (OrderSelect(i, SELECT_BY_POS))
      {  
         tip = OrderType();
         if (OrderSymbol()==Symbol())
         {
            OSL = OrderStopLoss();
            OTP = OrderTakeProfit();
            if ((OSL==0&&stoploss!=0)||(OTP==0&&takeprofit!=0))
            {  
               OOP   = OrderOpenPrice();
               Ticket = OrderTicket();
               if (tip==OP_BUY || tip==OP_BUYSTOP || tip==OP_BUYLIMIT)             
               {
                  if (takeprofit!=0) TP = NormalizeDouble(OOP + takeprofit*Point,Digits); else TP=OTP;
                  if (stoploss!=0)   SL = NormalizeDouble(OOP - (stoploss+SPREAD)* Point,Digits); else SL=OSL;       
                  if (OrderModify(Ticket,OOP,SL,TP,0,White)) Print("SetStop ",Ticket," SL ",OSL," -> ",SL,"   TP ",OTP," -> ",TP);
                  else Print(Symbol()," Error SetStop ",GetLastError(),"  Ticket ",Ticket);
               }                                         
               if (tip==OP_SELL || tip==OP_SELLSTOP || tip==OP_SELLLIMIT)        
               {
                  if (takeprofit!=0) TP = NormalizeDouble(OOP - takeprofit*Point,Digits); else TP=OTP;
                  if (stoploss!=0)   SL = NormalizeDouble(OOP + (stoploss+SPREAD)* Point,Digits); else SL=OSL;             
                  if (OrderModify(Ticket,OOP,SL,TP,0,White)) Print("SetStop ",Ticket," SL ",OSL," -> ",SL,"   TP ",OTP," -> ",TP);
                  else Print(Symbol()," Error SetStop ",GetLastError(),"  Ticket ",Ticket);
               } 
            }
         }
      }
   }
return(0);
}
//--------------------------------------------------------------------

